# LSB Test Execution Framework
# Cmdchk test module
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF with some parts
# derived from lsb-autotest written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

package Cmdchk_test;
use strict;

use Common;
use Packages;

require Tests::Test_common;
@Cmdchk_test::ISA = qw(Test_common);

=head ##
Class Cmdchk_test Inherits Test_common;
=cut ##

sub new {
    my $self  = Test_common->new();
    $self->{NAME} = "cmdchk";
    $self->{DISPLAYNAME} = "Command Check";
    $self->{DESCRIPTION} = "The lsb-cmdchk test suite verifies that all"
        ." the commands required by the LSB specification are present."
        ." It does not check the behaviour of those commands.";
    $self->{PACKAGES} .= " lsb-cmdchk";
    $self->{SOURCES} .= " runtime";
    $self->{BETA_SOURCES} .= " runtime";
    $self->{SNAPSHOT_SOURCES} .= " /snapshots/lsbcmdchk";
    
    bless($self);
    return $self;
}

sub journal {
    my $self = shift;

    # Parse the journal.
    store_journal_info(
        "Certification Tests/Command Tests/".$self->{DISPLAYNAME}, "command_check"
        ,"$results_dir/test_journals/command_check.journal", $self );
}

1; # return value
