# LSB Test Execution Framework
# Libchk test module
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF with some parts
# derived from lsb-autotest written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

package Libchk_test;
use strict;

use Common;
use Packages;

require Tests::Test_common;
@Libchk_test::ISA = qw(Test_common);

=head ##
Class Libchk_test Inherits Test_common;
=cut ##

sub new {
    my $self  = Test_common->new();
    $self->{NAME} = "libchk";
    $self->{DISPLAYNAME} = "Library Check";
    $self->{DESCRIPTION} = "The libchk test suite is used to check if"
        ." the runtime libraries contain all of the interfaces with correct"
        ." versions as specified by the LSB specification.";
    $self->{PACKAGES} .= " lsb-libchk";
    $self->{SOURCES} .= " runtime";
    $self->{BETA_SOURCES} .= " runtime";
    $self->{SNAPSHOT_SOURCES} .= " /snapshots/lsblibchk";

    bless($self);
    return $self;
}

sub journal {
    my $self = shift;
    
    store_journal_info(
        "Certification Tests/Static Interface Tests/".$self->{DISPLAYNAME}
        , "library_check"
        , "$results_dir/test_journals/library_check.journal", $self );
}

1; # return value
