# LSB Test Execution Framework
# Olver test module
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF with some parts
# derived from lsb-autotest written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

package Olver_test;
use strict;

use Common;
use Packages;

require Tests::Test_common;
@Olver_test::ISA = qw(Test_common);

=head ##
Class Olver_test Inherits Test_common;
=cut ##

sub new {
    my $self  = Test_common->new();
    $self->{NAME} = "olver";
    $self->{DISPLAYNAME} = "OLVER Tests";
    $self->{DESCRIPTION} = "An LSB OLVER test suite created "
            ."using the UniTESK technology";
    $self->{PACKAGES} .= " olver";
    $self->{SOURCES} .= " runtime";
    $self->{BETA_SOURCES} .= " runtime";
    $self->{SNAPSHOT_SOURCES} .= " /snapshots/tet-harness "
                ."/snapshots/olver-test";
    bless($self);
    return $self;
}

sub journal
{
    my $self = shift;
    
    store_journal_info(
        "Unofficial Tests/Runtime Interface Tests/".$self->{DISPLAYNAME},
        "olver_test", "$results_dir/test_journals/olver_test.journal", 
        $self);
}

1; # return value
