# LSB Test Execution Framework
# Python test module
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF with some parts
# derived from lsb-autotest written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

package Python_test;
use strict;

use Common;
use Packages;

require Tests::Test_common;
@Python_test::ISA = qw(Test_common);

=head ##
Class Python_test Inherits Test_common;
=cut ##

sub new {
    my $self  = Test_common->new();
    $self->{NAME} = "python";
    $self->{DISPLAYNAME} = "Python Runtime Tests";
    $self->{DESCRIPTION} = "The official package version of the LSB Python test suite."
            ." These tests are derived from Python's build-time tests.";
    $self->{PACKAGES} .= " lsb-tet3 lsb-test-python";
    $self->{SOURCES} .= " runtime";
    $self->{BETA_SOURCES} .= " runtime";
    $self->{SNAPSHOT_SOURCES} .= " /snapshots/python-test /snapshots/tet-harness";

    bless($self);
    return $self;
}

sub journal {
    my $self = shift;
    
    store_journal_info(
        "Certification Tests/Runtime Interface Tests/".$self->{DISPLAYNAME}
        , "python", "$results_dir/test_journals/python_test.journal", $self);
}

1; # return value
