# LSB Test Execution Framework
# Desktop-T2C test module
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF with some parts
# derived from lsb-autotest written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2007 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

package Desktop_t2c_test;
use strict;

use Common;
use Packages;

use Tests::X11::X11_common;
@Desktop_t2c_test::ISA = qw(X11_common);

=head ##
Class Desktop_t2c_test Inherits X11_common
=cut ##

sub new {
    my $self  = X11_common->new();
    $self->{NAME} = "desktop-t2c";
    $self->{DISPLAYNAME} = "Desktop-T2C Tests";
    $self->{DESCRIPTION} = "A set of LSB desktop test suites created "
            ."using the T2C (\"Template-to-C\") framework";
    $self->{PACKAGES} .= " lsb-tet3 lsb-test-desktop-t2c";
    $self->{SOURCES} .= " appbat runtime";
    $self->{BETA_SOURCES} .= " appbat runtime";
    $self->{SNAPSHOT_SOURCES} .= " /snapshots/tet-harness "
                ."/snapshots/t2c-desktop-tests";
    bless($self);
    return $self;
}

sub journal
{
    my $self = shift;
    
    store_journal_info(
        "Certification Tests/Runtime Interface Tests/".$self->{DISPLAYNAME},
        "desktop_t2c_test", "$results_dir/test_journals/desktop_t2c_test.journal", 
        $self);
}

1; # return value
