#!/usr/bin/perl -w

# LSB Test Execution Framework
# Administration Page Module (tests_admin.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("LSB Distribution Testkit Administration", "admin");

print "<h1>LSB Distribution Testkit Administration</h1>\n";

print show_error_dlg("");

`head -n 1 $SERVER_PARAM{APP_DATA}/log/dtk-server.log.8888 2>/dev/null` =~ m/PID: (\d+)\.$/i;
my $serv_pid = $1;

my $serv_status;
my $serv_stop_button;
if ($serv_pid) {
	$serv_status = "<font color=\"green\">Running</font> (PID: $serv_pid)";
	$serv_stop_button = " onclick=\"javascript:going_to_kill($serv_pid, 'server');\"";
}
else {
	$serv_status = "<b><font color=\"red\">PID not found!</font></b>";
	$serv_stop_button = " disabled=\"disabled\"";
}

my $test_status;
my $test_stop_button;
my $running = 0;
if (-f "/tmp/tests_output.8888") {
	`head -n 1 /tmp/tests_output.8888 2>/dev/null` =~ m/PID:\s*(\d+),\s*CHLD_PID:\s*(\d+)/i;
	my $PID = $1;
	my $kill_PID = $2;
	$running = is_process_running($PID);
	if ($running) {
		$test_status = "<font color=\"green\">Running</font> (PID: $PID)";
		$test_stop_button = " onclick=\"javascript:going_to_kill($kill_PID, 'tests');\"";
	}
}
if (!$running) {
	$test_status = "<font color=\"red\">Not running</font>";
	$test_stop_button = " disabled=\"disabled\"";
}

print <<DATA;
<div id="ajax_loading" style="display: none; position: fixed; width: 13em; height: 5.8em; top: 40%; left: 50%; margin-top: -2.9em; margin-left: -7.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;"><div align="center">
Please, wait...<br />
<img src="images/environment-spacer.gif" width="1" height="5" alt="" /><br />
<img src="images/ajax_progress.gif" width="16" height="16" alt="" /><br />
<img src="images/environment-spacer.gif" width="1" height="7" alt="" /><br />
<input type="button" name="ajax_abort" id="ajax_abort" value="Abort" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 6em;" onclick="javascript:onAbort();" />
</div></div>

<div id="disable_layer" style="display: none; position: fixed; width: 100%; height: 100%; top: 0px; left: 0px; background-color: gray; opacity: 0.4; filter: alpha(opacity=40);"></div>

<table cellpadding="0" cellspacing="0" id="server_stopped" style="display: none; position: fixed; width: 25em; height: 6em; top: 40%; left: 50%; margin-top: -3em; margin-left: -12.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; vertical-align: middle; padding: 6px;"><tr><td>
<font size="+2" color="red"><b>Server is stopped</b></font>
</td></tr></table>

<table class="main" cellpadding="2" cellspacing="2">
  <tr>
    <td style="width: 8em;">Server status:</td>
    <td style="width: 12.5em;" id="server_status">$serv_status</td>
    <td><input type="button" id="server_stop" style="width: 7.5em;" value="Stop server"$serv_stop_button /></td>
  </tr>
  <tr>
    <td>Tests status:</td>
    <td id="tests_status">$test_status</td>
    <td><input type="button" id="tests_stop" style="width: 7.5em;" value="Stop tests"$test_stop_button /></td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
var err_area = document.getElementById('error_msg_area');
var err_text = document.getElementById('error_msg_text');

// AJAX
var req;
var busy = false;
var ajax_srv_url = document.location.protocol + '//' + document.location.host + '/ajax_srv.pl';
var progressDiv = document.getElementById('ajax_loading');
if (navigator.appName == 'Microsoft Internet Explorer')
	progressDiv.style.height = '7.5em';

function going_to_kill(pid, what) {
	if (!busy) {
		if (confirm("Do you really want to kill the process tree (PID: " + pid + ")?")) {
			setBusyOn();
			loadXMLDoc(ajax_srv_url + '?action=stop_tests&tree=' + what, 'GET', null);
		}
	}
}

function setBusyOn() {
	busy = true;
	setTimeout("showAjaxProgress()", 150);
}

function showAjaxProgress() {
	if (busy)
		progressDiv.style.display = '';
}

function setBusyOff() {
	busy = false;
	progressDiv.style.display = 'none';
}

function onAbort() {
	setBusyOff();
	req.abort();
}

function loadXMLDoc(url, method, post_params) {
	err_area.style.display = 'none';
	if (window.XMLHttpRequest) {        // native XMLHttpRequest object
		req = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) {    // IE/Windows ActiveX version
		try {
			req = new ActiveXObject('Msxml2.XMLHTTP');
		}
		catch (e) {
			try {
				req = new ActiveXObject('Microsoft.XMLHTTP');
			}
			catch (e) {
				alert('Sorry, your browser does not support AJAX');
				return false;
			}
		}
	}
	if (!req) {
		alert('Sorry, your browser does not support AJAX');
		return false;
	}

    req.onreadystatechange = processReqChange;
    req.open(method, url, true);
	req.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	req.setRequestHeader('If-Modified-Since', 'Tue, 01 Jan 1980 00:00:00 GMT');
	req.setRequestHeader('Content-length', (post_params ? post_params.length : 0));
	req.setRequestHeader('Connection', 'close');
    req.send(post_params);

	function processReqChange() {
		if (req.readyState == 4) {     // Finished
			setBusyOff();
	        if (req.status == 200) {
				if (req.responseXML.getElementsByTagName('error').length > 0) {
		            var error_text = req.responseXML.getElementsByTagName('error')[0].childNodes[0].nodeValue;
	            	err_text.innerHTML = error_text;
	            	err_area.style.display = '';
				}
				else {
	            	err_area.style.display = 'none';
					if (req.responseXML.getElementsByTagName('stopped').length > 0) {
						var stopped = req.responseXML.getElementsByTagName('stopped')[0].childNodes[0].nodeValue;
						var what = req.responseXML.getElementsByTagName('stopped')[0].getAttribute('id');
						var server_status = document.getElementById('server_status');
						var server_stop = document.getElementById('server_stop');
						var tests_status = document.getElementById('tests_status');
						var tests_stop = document.getElementById('tests_stop');
						if (server_status && server_stop && tests_status && tests_stop) {
							if (what == 'tests') {
								tests_status.innerHTML = '<font color="red">Not running</font>';
								tests_stop.disabled = true;
							}
							else if (what == 'server') {
								server_status.innerHTML = '<font color="red">Not running</font>';
								server_stop.disabled = true;
								tests_status.innerHTML = '<font color="red">Not running</font>';
								tests_stop.disabled = true;
								var server_stopped = document.getElementById('server_stopped');
								server_stopped.style.display = '';
								var show_disable_layer = true;
								if (navigator.appName == 'Konqueror') {
									show_disable_layer = false;
								}
								else if (navigator.appName == 'Microsoft Internet Explorer') {
									var idx = navigator.appVersion.indexOf('MSIE ');
									if (idx == -1) {
										show_disable_layer = false;
									}
									else {
										if (navigator.appVersion.substr(idx + 5, 1) < '7')
											show_disable_layer = false;
									}
								}
								if (show_disable_layer)
									document.getElementById('disable_layer').style.display = '';
							}
						}
					}
				}
	        }
	        else {
	            alert('Error in AJAX call:\\n' + req.statusText);
	        }
	    }
	}
}
// ]]>
</script>
DATA

print_footer();
