#!/usr/bin/perl -w

# LSB Test Execution Framework
# Help Page Module (tests_help.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("Information", "help");

print <<DATA;
<a name="top"></a>
<p align="justify"><b>LSB Distribution Testkit Manager</b> provides a web interface for executing LSB tests.</p><br />
<table style="border: dashed 1px #2f6fab; padding: 5px; white-space: nowrap; background-color: #f9f9f9;"><tr><td>
<h3>Help Contents</h3>
<ol>
  <li><a href="#get_cert">Get&nbsp;Certified page</a></li>
  <li><a href="#conf">Custom&nbsp;Tests page</a></li>
  <li><a href="#exec">Execution page</a></li>
  <li><a href="#manappbat">Manual Application Battery Tests page</a></li>
  <li><a href="#results">Results page</a>
    <ul>
      <li><a href="#sumreport">Summary Report page</a></li>
      <li><a href="#detreport">Detailed Report page</a></li>
    </ul>
  </li>
  <li><a href="#help">Help page</a></li>
  <li><a href="#about">About page</a></li>
  <li><a href="#admin">Administration page</a></li>
  <li><a href="#troubleshooting">Troubleshooting</a></li>
</ol></td></tr>
</table>
<br />

<a name="get_cert"></a><h1>Get&nbsp;Certified</h1>
<p align="justify">
Open this page to start normal LSB certification. This page is very similar to the <a href="#conf"><b>Custom&nbsp;Tests</b></a> page, but has some restrictions implied by the certification process:
</p>
<ul>
<li>The <b>Your name</b> and <b>Organization</b> fields are mandatory.</li>
<li>It is impossible to turn off using Internet: all the test packages must be downloaded by the LSB Distribution Testkit if they are not available locally.</li>
<li>It is impossible to use short scenarios.</li>
<li>The test selection list is turned off (the most recent versions of all the necessary tests are executed).</li>
<li>The additional option <b>LSB&nbsp;Profile</b> allows to test against different LSB profiles (it is not needed for the <a href="#conf"><b>Custom&nbsp;Tests</b></a> page as there are more flexible settings available).</li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="conf"></a><h1>Custom&nbsp;Tests</h1>
<p align="justify">
This page allows you to configure the test system. The following options are present:
</p>
<ul>
<li><b>Your name:</b><br />The name of the user who started the tests. This field is reserved for future use (currently not used).</li>
<li><b>Organization:</b><br />The name of your organization. This field is reserved for future use (currently not used).</li>
<li><b>E-mail:</b><br />Specify your E-mail here. It will be used for sending the report after the tests finish.</li>
<li><b>Send report via E-mail</b><br />Choose whether to send the report via E-mail using the specified address. Make sure that your Mail Transfer Agent is customized properly.<br />Please note that the all the journals are packed and attached to this mail, so its size may be up to 4 MB or even larger.</li>
<li><b>Additional options</b><br />Less important additional settings are shown here. To show/hide them just click the orange header. This block contains the following settings:
  <ul>
  <li><a name="keep_packages"></a><b>Keep packages</b><br />Don&rsquo;t remove packages that were installed to execute the tests. If this option is turned off, the packages are deinstalled after the tests are finished. Keeping the packages allows the tests to start next time without reinstalling, which saves time.<br /><font color="blue"><b>Warning:</b></font> If you set the <b>Keep packages</b> option, please do not run tests for different architectures. The Framework cannot determine which architecture the installed package is designed for, and could run the wrong set of tests. For example, you may want to run tests for the <b>x86_64</b> platform, but start the tests for the <b>ia32</b> platform instead, because those tests were already installed.</li>
  <li><a name="short_scenarios"></a><b>Short scenarios</b><br />This option can set up runing a reduced set of tests, which can take less time. It is present only in test versions of the LSB Distribution Testkit and designed to simplify the process of reproducing errors when providing feedback.</li>
  <li><b>Verbose Level:</b><br />Specifies how much information should be given by the tests to the output console.</li>
  <li><b>Comments:</b><br />Here you may write comments with any additional information. These comments are stored in the execution report and shown in the <a href="#results"><b>Results</b></a> page.</li>
  </ul>
</li>
<li><b>Use Internet for downloading the tests</b><br />This checkbox allows you to specify not to use any Internet connections for downloading the test packages. If it is turned off, you will not be able to refresh the list of the tests.</li>
<li><b>Architecture:</b><br />Select the machine architecture here. NOTE: Only architectures that are compatible with the machine being tested are listed.</li>
<li><b>LSB Version:</b><br />This combobox specifies the LSB version to check.</li>
<li><b>Refresh list</b><br />This button causes the Testkit to connect to the <a href="ftp://linux-foundation.org/" target="_blank">LF&rsquo;s FTP server</a>, obtain the list of the latest test packages, and update the list of packages shown below based on downloaded and newly available packages.</li>
</ul>
<p align="justify">
Below is the list of available test packages present. At first start it will most likely be empty. To get the full list press the <b>Refresh list</b> button (if the list is empty this button changes its name to <b>Get List</b>). It may take about 20 to 40 seconds depending on your Internet connection speed and load of the servers. The list from FTP is cached, so you don&rsquo;t need to refresh it every time. If the list has not been updated for some time (more than 24 hours), the LSB Distribution Testkit shows you a warning that the list may be out-of-date.<br />
The list of test suites consists of four columns. The first column contains the name of the test suite and a checkbox indicating whether to execute this test or not (if it was set and then disabled, e.g. when you turned off the <b>Use Internet connection</b> checkbox, the test will not be executed). The other three columns allow you to choose which version of the test suite to execute. These columns are:
</p>
<ol>
<li><b>Localhost</b><br />The version of the test suite that is present on your local hard disk (either downloaded into the <font color="blue">$SERVER_PARAM{APP_DATA}/lsb-packages</font> directory or one of its subdirectories, or already installed).</li>
<li><b>FTP</b><br />The latest <b>stable</b> version present on the LF&rsquo;s FTP server.</li>
<li><b>FTP (beta)</b><br />The latest <b>beta</b> version present on the LF&rsquo;s FTP server.</li>
</ol>
<p align="justify">
If some of the items do not contain any version number, it means that the corresponding version is not available.
</p>
<p align="justify">
All the test suites are divided into the following groups and subgroups.
</p>
<ul><li><a name="cert"></a><b>[Certification Tests]</b>: Test suites that are used for certification of distributions for conformance to the LSB Specifications.
        <ul><li><a name="cmdtests"></a><b>[Command Tests]</b>: Test suites that verify the commands required by LSB specification.
                <ul><li><a name="cmdchk"></a><font color="green">Command Check (lsb-cmdchk)</font>: This test suite verifies that all the commands required by the LSB specification are present. It does not check the behaviour of those commands.</li></ul>
            </li>
            <li><a name="sitests"></a><b>[Static Interface Tests]</b>: Test suites that verify interfaces in the runtime libraries.
                <ul><li><a name="libchk"></a><font color="green">Library Check (lsb-libchk)</font>: This test suite is used to check if the runtime libraries contain all of the interfaces with correct versions as specified by the LSB specification.</li></ul>
            </li>
            <li><a name="ritests"></a><b>[Runtime Interface Tests]</b>: Test suites for testing LSB runtime environments for conformance to the LSB Specifications.
                <ul><li><a name="runtime"></a><font color="green">Core Tests</font>: This is a test suite for testing core interfaces for conformance to the LSB Specifications.</li>
                    <li><a name="desktop"></a><font color="green">Desktop Tests</font> (LSB 3.1 and 3.2) consist of the following test suites:
                        <ul><li><font color="green">GTK Tests</font></li>
                            <li><font color="green">Libpng Tests</font></li>
                            <li><font color="green">Libxml Tests</font></li>
                            <li><font color="green">Qt3 Tests</font></li>
                            <li><font color="green">Qt4 Tests</font> (in LSB 3.1 it is optional)</li>
                            <li><font color="green">Fontconfig Tests</font></li>
                        </ul>
                    </li>
                    <li><a name="t2c"></a><font color="green">Desktop-T2C Tests</font> (LSB 3.2): The normal-quality tests for libatk-1.0, libglib-2.0, libgmodule-2.0 and libfontconfig developed using the T2C Framework.</li>
                    <li><a name="libstdcpp"></a><font color="green">LibStdC++ Tests</font>: This is the libstdc++-v3 testsuite from gcc version 3.4.3, modified to run against an installed version of libstdc++ without requiring a compiler.</li>
                    <li><a name="perl"></a><font color="green">Perl Tests</font> (LSB 3.2): Testsuite for testing installed perl interpreter.</li>
                    <li><a name="python"></a><font color="green">Python Tests</font> (LSB 3.2): Testsuite for testing installed python interpreter.</li>
                    <li><a name="vsw4"></a><font color="green">X11 Tests (Vsw4)</font> (LSB 3.0 and 3.1): LSB X Window System test suite. These tests are derived from the VSW4 XTest test suites.</li>
                    <li><a name="xts5"></a><font color="green">X11 Tests (Xts5)</font> (LSB 3.2): This is a binary version of the LSB X Window System test suite. These tests are derived from the XTS5 test suites. They are used instead of VSW4 since LSB 3.2.</li>
                </ul>
            </li>
            <li><a name="abtests"></a><b>[Application Battery Tests]</b>: Tests that verify the correct operation of binary applications from the LSB application battery.
                <ul><li><a name="apache_ab"></a><font color="green">Apache</font>: versatile, high-performance HTTP server.</li>
                    <li><a name="expect_ab"></a><font color="green">Expect</font>: a program that &lsquo;talks&rsquo; to other programs.</li>
                    <li><a name="groff_ab"></a><font color="green">Groff</font>: a document formatting system.</li>
                    <li><a name="lynx_ab"></a><font color="green">Lynx</font>: a text-based Web browser.</li>
                    <li><a name="python_ab"></a><font color="green">Python</font>: an interpreted, interactive, object-oriented programing language.</li>
                    <li><a name="raptor_ab"></a><font color="green">Raptor</font>: parsers and serializers for RDF.</li>
                    <li><a name="rsync_ab"></a><font color="green">Rsync</font>: a program for synchronizing files over a network.</li>
                    <li><a name="samba_ab"></a><font color="green">Samba</font>: a file and print server for SMB/CIFS clients.</li>
                    <li><a name="tcl_ab"></a><font color="green">Tcl</font>: an embedded scripting language.</li>
                    <li><a name="xpdf_ab"></a><font color="green">Xpdf</font>: a PDF file viewer for X Window System.</li>
                </ul>
            </li>
            <li><a name="mantests"></a><b>[Manual Tests]</b>: All the tests that need user interaction.
                <ul><li><a name="appbat"></a><font color="green">Application Battery</font>: The Application Battery tests that cannot be automated. The following tests are included:
                        <ul><li><a name="celestia"></a><font color="green">Celestia</font>: real-time visual space simulation.</li>
                            <li><a name="pidgin"></a><font color="green">Gaim/Pidgin</font>: multi-protocol instant messaging (IM) client.</li>
                            <li><a name="leafpad"></a><font color="green">Leafpad</font>: simple GTK+-based text editor.</li>
                            <li><a name="scribus"></a><font color="green">Scribus</font>: desktop publishing tool based on Qt.</li>
                            <li><a name="xpaint"></a><font color="green">Xpaint</font>: paint program for X Window System.</li>
                            <li><a name="xpdf_man"></a><font color="green">Xpdf</font>: PDF file viewer for X Window System (the tests is partly automated and hence listed in both Automatic and Manual sections).</li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </li>
    <li><a name="unoff"></a><b>[Unofficial Tests]</b>: Tests that are not used for certification, but can be used for futher LSB compliance testing.
        <ul><li><a name="uritests"></a><b>[Runtime Interface Tests]</b>: Test suites for testing LSB runtime environments for conformance to the LSB Specifications.
                <ul><li><a name="xts5_uri"></a><font color="green">XTS5 Tests</font> This test is unofficial in LSB 3.0 and 3.1 only. Since LSB 3.2 it became official X11 test instead of VSW4.</li></ul>
                <ul><li><a name="qt3_azov_uri"></a><font color="green">Qt3 Azov Tests</font> This test is unofficial in LSB 3.0 and 3.1 only. Since LSB 3.2 it became official Qt3 test.</li></ul>
                <ul><li><a name="qt4_azov_uri"></a><font color="green">Qt4 Azov Tests</font> This test is unofficial in LSB 3.0 and 3.1 only. Since LSB 3.2 it became official Qt4 test.</li></ul>
                <ul><li><a name="olver_uri"></a><font color="green">OLVER Tests</font> This test is unofficial in LSB 3.0 and 3.1 only. Since LSB 3.2 it became official test suite for testing core interfaces for conformance to the LSB Specifications.</li></ul>
            </li>
        </ul>
    </li>
</ul>
<p align="justify">
Some of the tests may have additional options. Currently these are <b>Command Check</b>, <b>Library Check</b> and <b>Desktop</b> tests (in LSB 3.1 and above only).
</p>
<p align="justify">
When you select the tests, you can see the approximate summary size of the packages to be downloaded (in the <b>Download size:</b> field just above the list of the tests). If you turn the option <b>Use Internet connection for downloading the tests</b> off, all test packages which need downloading will be automatically disabled.
</p>
<p align="justify">
After you selected the test packages to run you may press the button <b>Run selected tests</b> located at the bottom of the page. This will redirect you immediately to the next page (<a href="#exec"><b>Execution</b></a>) and the tests will start. If the tests are already (or still) running you will get the error message at the top of the page, because it is currently impossible to run several tests instances simultaneously.
</p>

<a name="profile_management"></a><h3>User Profile Management</h3>
<p align="justify">
This section allows you to save/load all the settings listed above in different user profile files. To save the settings just specify the new profile name in the edit box (or use the drop-down list to select the existing profile and overwrite it), and then press the <b>Save</b> button. To load a previously saved profile, select it from the drop-down list and press <b>Load</b>. The <b>Delete</b> button allows you to delete the old profiles that are no longer needed.<br />
<b>Note:</b> The profile is not automatically saved when you run the tests! The settings are just stored in a temporary <i>session profile</i> which is automatically removed when it is no longer used. So if you wish to use the same set of options later, please save it explicitly, via the <b>Save</b> button.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="exec"></a><h1>Execution</h1>
<p align="justify">
This page allows you to watch the tests execution progress. If the tests are already running, you may open this page to watch the progress (even from another computer). If the tests are not running at the moment, you may select the user profile that was saved earlier on the <a href="#conf"><b>Custom&nbsp;Tests</b></a> page and run the tests by pressing the <b>Start</b> button. The <b>Stop</b> button allows you to forcibly stop the tests execution.
</p>
<p align="justify">
Just below, the current status of the tests execution and its output console are shown. The console is refreshed automatically about every second and displays all output for the tests (both <b>stdout</b> and <b>stderr</b>). If the tests were stopped forcibly, the received signal number is shown. After the correct completion of the tests you are automatically redirected to the <a href="#sumreport"><b>Summary Report</b></a> page with the results of the tests just finished. You can then continue with manual tests if necessary (see below).
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="manappbat"></a><h1>Manual Application Battery Tests page</h1>
<p align="justify">
This page allows you to perform manual tests. You can open it from the <a href="#results"><b>Results</b></a> page or from the intermediate <a href="#sumreport"><b>Summary Report</b></a> page.
</p>
<p align="justify">
The left pane contains the full list of all the manual tests (it depends on the LSB version and test suites selected). To perform the particular test you can click the name of the test in the left column of the table. To the right from the test name its status is shown:
</p>
<ul>
  <li><b><font color="blue">Not finished</font></b>: The test was not performed yet.</li>
  <li><b><font color="green">Passed</font></b>: The test was performed without problems.</li>
  <li><b><font color="red">Failed</font></b>: The test was performed with some problems.</li>
</ul>
<p align="justify">
When all the tests are performed, the <b>Finish</b> button located below the table becomes active. When you press it, the new reports are generated and you are redirected to the updated <a href="#sumreport"><b>Summary Report</b></a> page.
</p>
<p align="justify">
The right pane contains the steps of the test selected. Each test is a set of "yes-no" questions usually containing the description of the step to be performed and the result expected. You need to perform all the steps and answer if you got the expected results.  After you answered all the questions and (optionally) wrote additional comments, press the <b>Finish test</b> button. Your answers are then saved to the journal and the next test is opened automatically.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="results"></a><h1>Results</h1>
<p align="justify">
This page shows the table with the full list of the tests execution results. The table contains the following columns:
</p>
<ul>
  <li><b>Date/Time</b><br />Here the date and time are shown, when the tests were finished. At the left edge of this column a status-icon is shown:
    <ul>
      <li><img src="images/CertPassed.png" alt="CertPass" width="33" height="30" /> The certification tests passed.</li>
      <li><img src="images/CertFailed.png" alt="CertFail" width="33" height="30" /> The certification tests failed.</li>
      <li><img src="images/TestsPassed.png" alt="TestsPassed" width="33" height="30" /> The custom set of tests passed.</li>
      <li><img src="images/TestsFailed.png" alt="TestsFailed" width="33" height="30" /> The custom set of tests failed.</li>
    </ul>
    The translucent status icon means that the manual tests were selected for this test run (either explicitly or implicitly) but were not performed yet. In this case the "<i>passed</i>" or "<i>failed</i>" status applies to the automatic tests that have already been finished.<br />
    In the cell&rsquo;s right-bottom corner there are several additional icons:
    <ul>
      <li><img src="images/run_manual.png" alt="" width="16" height="16" /> This icon is present only when manual tests were not finished yet. Clicking on it redirects you to the <a href="#manappbat"><b>Manual Application Battery Tests</b></a> page.</li>
      <li><img src="images/report_details.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#detreport"><b>Detailed Report</b></a> page for this test run.</li>
      <li><img src="images/report_summary.gif" alt="" width="16" height="16" /> Clicking on this icon opens the <a href="#sumreport"><b>Summary Report</b></a> page for this test run (clicking the date/time link does the same).</li>
    </ul>
  </li>
  <li><b>Summary</b><br />This column shows the general results of the tests (how many tests passed and failed).</li>
  <li><b>Comment</b><br />Here the comments entered on the <a href="#conf"><b>Custom&nbsp;Tests</b></a> page are shown.</li>
</ul>
<p align="justify">
To remove the reports that are no longer needed, just mark them with the checkboxes shown at the left edge of the corresponding lines and press the <b>Remove selected</b> button below the table.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="sumreport"></a><h2>Summary Report page</h2>
<p align="justify">
This page shows the summary status of the automatic and manual tests:
</p>
<ul>
  <li><b>PASSED</b> means that the tests have been passed.</li>
  <li><b>FAILED</b> means that there were some problems.</li>
  <li><b>NOT SELECTED</b> is shown when you selected no manual tests, only automatic ones (or vice versa).</li>
  <li><b>NOT FINISHED YET</b> can be shown for the manual tests only. It means that you did not perform the manual tests yet.</li>
  <li><b>NOT REQUIRED</b> is shown for manual tests when a certification test run was performed that did not require manual tests (<b>Core &amp; C++</b> profile).</li>
</ul>
<p align="justify">
If the manual tests are not performed you can run them by clicking the <b>NOT FINISHED</b> status text in the table.
</p>
<p align="justify">
Below the table additional information is shown, depending on the tests selected and their status. Generally, you can find there what to do with failing tests, how to apply for certification, where to find the journal files and how to return back to this page after closing it.
</p>
<p align="justify">
There is also a link <b>Apply for certification</b> which allows you submitting
the results to the <a href="http://$cert_sys_host$cert_sys_base" target="_blank">Certification System</a>.<br />
<b>Note:</b> you can apply for certification with results of a <b>certification</b> test run only.
For custom test results there is the <b>Upload the test results</b> link instead which allows you to upload additional results (if needed) for a product already being certified.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="detreport"></a><h2>Detailed Report page</h2>
<p align="justify">
This page contains the detailed report about the test results. It consists of the following sections:
</p>
<ul>
  <li><b>Test info</b><br />
    Contains the information about the machine where the tests were executed.</li>
  <li><b>Tests executed</b><br />
    An index with links to details and a short summary for each test.<br />
    <a name="No_result"></a>If <b>No result</b> is shown for an automatic test, this means that the test failed to run or was interrupted during the execution. For a manual test <b>No result</b> means that the test was not yet performed.
  </li>
  <li><b>Details for each test</b><br />
      Here the information from the test journal is shown, including the list of warnings and errors detected. You may click any line with particular problem to see more details about this problem. The <b>Severity</b> column contains the status of the problem. Here are the descriptions for some of the status messages:
      <ul>
          <li><b>Warning</b> means that this some non-critical problem occured.</li>
          <li><b>Failed</b> means that a severe problem occured (it usually implies that the distribution is not LSB compliant).</li>
          <li><a name="FIP"></a><b>FIP</b> stands for "<i>Futher Information Provided</i>". These FIP results occur when the test suite is unable to determine whether a result is a PASS or a FAIL. For LSB Certification you have to resolve each FIP case and upload your comments (in plain text) along with the test journals.</li>
          <li><b>Quelled</b> means that the problem is waived and will not prevent the distro from being LSB certified.</li>
      </ul>
  </li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="help"></a><h1>Help</h1>
<p align="justify">
Contains the description of the web-interface of LSB Distribution Testkit (the page you are reading now).
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="about"></a><h1>About</h1>
<p align="justify">
Contains the general information about LSB Distribution Testkit: its version, license, etc.
</p>
<p align="right"><a href="#top">Back to top</a></p>

<a name="admin"></a><h1>Administration</h1>
<p align="justify">
This page is designed for performing administrative tasks. Please be careful doing anything on this page!
</p>
<p align="justify">
Currently the following items are present:
</p>
<ul>
<li><b>Server status:</b><br />Shows current status of the web-server and its PID. The button <b>Stop server</b> shuts the server down. Please note that you will not be able to use the web interface after that!</li>
<li><b>Tests status:</b><br />Shows current status of the tests and PID of their parent process. The button <b>Stop tests</b> forcibly stops execution of the tests (it has the same meaning as the <b>Stop</b> button on the <a href="#exec"><b>Execution</b></a> page).</li>
</ul>
<p align="right"><a href="#top">Back to top</a></p>

<a name="troubleshooting"></a><h1>Troubleshooting</h1>
<ul>
<li>Some locales are required for libstdc++ test. That may turn into a problem for your distro. If that&rsquo;s the case, maybe the following solution for Debian will help you:<br />
<a href="http://people.debian.org/~taggart/lsb/tests.html" target="_blank">http://people.debian.org/~taggart/lsb/tests.html</a>
</li>

<li>In the case when the autotest couldn&rsquo;t find fonts, there is a workaround. First, find the font directory (see the files <font color="blue"><code>/etc/X11/xorg.conf</code></font> and <font color="blue"><code>/etc/X11/fs/config</code></font>). Also you may try the command<br />
<code>find / -name 75dpi</code><br />
to find all 75dpi font directories. Choose the appropriate font directory and make sure that the following subdirectories are present: &lsquo;misc&rsquo;, &lsquo;75dpi&rsquo;, &lsquo;100dpi&rsquo;.<br />
Autotest tries to find these subdirectories in the following locations:<br />
<ul>
<li><code>/usr/X11R6/lib/X11/fonts/</code></li>
<li><code>/usr/share/fonts/X11/</code></li>
<li><code>/usr/share/X11/fonts/</code></li>
<li><code>/usr/share/fonts/</code></li>
</ul>
Create symlinks to the found directories (misc, 75dpi, 100dpi) into one of the directories listed above so that autotest could find them next time.
</li>

<li>If you have no 100dpi fonts installed, you should install them using the tools provided by your distro.</li>
</ul>

<p align="justify">
Here are some of the possible errors and the ways of solving them.
</p>
<ul>
<li><b>Error: Couldn&rsquo;t recognize the host platform.</b><br />
If you believe that your platform is one of the listed supported platforms, but its name wasn&rsquo;t recognized by the Test Execution Framework (TEF), please first of all send the bugreport (see contacts below). If you use the command-line tool, you can just specify the platform using the -p parameter, e.g.:<br />
<code>./lsb-tef.pl -p ppc32</code><br />
to state the platform is ppc32. Unfortunately, there is no way to specify the platform with the web UI.<br />
(You can identify your platform using the command <code>uname -i</code>.)
</li>

<li><b>Error: Couldn&rsquo;t recognize package manager for this distro.</b><br />
or <b>Error: ... Unknown package manager ...</b><br />
If you are sure that your package manager is <b>RPM</b> or <b>dpkg</b> with <b>alien</b> installed, there is a method to state the correct package manager. If you use the command-line tool, you can just specify the package manager using the -pm option, e.g.<br />
for RPM: <code>./lsb-tef.pl -pm RPM</code><br />
for dpkg: <code>./lsb-tef.pl -pm dpkg</code><br />
Unfortunately, there is no way to specify the package manager with the webUI.
</li>

<li><b>Error: Couldn&rsquo;t find LSB loader (loader_name) for this platform (host_platform).</b><br />
or <b>Error: No LSB modules are available.</b><br />
Most likely, you haven&rsquo;t installed the LSB support modules. You should install them using the tools provided by your distribution. (For example, <code>apt-get install lsb</code> should work on Debian-based distros.)
</li>

<li><b>Error: Couldn&rsquo;t find a required tool: &lsquo;&lt;some tool&gt;&rsquo;</b><br />
This error message occurs when you are missing a tool used by TEF. Please install the tool in the usual way for your distribution.
</li>

<li><b>Error: Can&rsquo;t find lsb-autotest in &lt;some_dir&gt;.</b><br />
&lsquo;lsb_autotest&rsquo; is a tool used by TEF to automatically run the tests. TEF tries to find lsb_autotest at the specified location (usually at manager/autotest). Check that the file manager/autotest/lsb-autotest exists and has appropriate rights to be executed by root (TEF runs tests as root). If the file doesn&rsquo;t exists, it is most likely that TEF wasn&rsquo;t installed correctly; reinstalling it should fix the problem.
</li>

<li><b>Error: Could not open problem database &lt;file_name&gt;</b><br />
&lsquo;problem_db&rsquo; is a file that contains information about some known problems. Information in this file is used for the report creation. This file should be located at manager/autotest-ext/problem_db. Check that this file exists and has appropriate privileges to be read by root (TEF works as root). If the file doesn&rsquo;t exists, it is most likely that TEF wasn&rsquo;t installed correctly; reinstalling it should fix the problem.
</li>

<li><b>Error: FTP init failed.</b><br />
or <b>Error: FTP login (anonymous) failed.</b><br />
This usually indicates a poor Internet connection or high load of the LF&rsquo;s FTP server. Try again later.<br />
If you have all the test packages downloaded (all tests are available at the first column <b>localhost</b> on the <a href="#conf"><b>Custom&nbsp;Tests</b></a> page of webUI), you can choose not to download the newer packages, and TEF will not connect to the FTP server.
</li>

<li><b>Error: Failed to execute: &lt;command&gt;</b><br />
or <b>Error: Couldn&rsquo;t open file &lsquo;&lt;file_name&gt;&rsquo; for writing.</b><br />
or <b>Error: Failed to copy: ...</b><br />
This means that the TEF failed to fulfil some service operation. Your bugreport with the log of console output attached will be truly appreciated.
</li>

<li><b>Error: The vsw4 test can&rsquo;t be run. Please install the Xvfb server first.</b><br />
If this error appears despite you have already installed <b>Xvfb</b>, please, restart the DTK server so that the PATH variable was updated.
</li>

<li><b>Error: All selected tests are unavailable.</b><br />
This error can appear only if most of required test packages at the FTP server of the Linux Foundation (ftp.linux-foundation.org) are deleted or moved to another directory. This may happen for 'beta' LSB versions when the corresponding directories at the FTP server are not yet populated with test packages.
</li>

</ul>

<p align="justify">
If you can&rsquo;t find a suitable solution, you can write to <a href="mailto:linux\@ispras.ru">linux\@ispras.ru</a>.
</p>
<p align="right"><a href="#top">Back to top</a></p>
DATA

print_footer();
